#define _REENTRANT
#include <iostream.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <stdlib.h>
#include <fstream.h>
#include <unistd.h>
#include <math.h>
#include <errno.h>
#include <string.h>
#include <pthread.h>
#include <time.h>

pthread_t CreateThread();
void JoinThread(pthread_t pid);
void * robsort(void *);

int main() 
	{
	int num_processors = sysconf(_SC_NPROCESSORS_CONF);
	int numthreads;
	cout << "It looks like you have " << num_processors << " processor(s)." << endl;
	cout << "How many threads?: ";
	cin >> numthreads;
	pthread_t tid[numthreads];
	cout << "Creating " << numthreads << " Threads...." << endl;

	#ifdef HAVE_PTHREAD_SETCONCURRENCY
        (void) pthread_setconcurrency(numthreads);
	#else
	#ifdef HAVE_THR_SETCONCURRENCY
	/* Set Solaris LWP concurrency to 2 */
        thr_setconcurrency(numthreads);
	#endif
	#endif

	for (int i=0; i<numthreads; i++)
        	{
        	tid[i] = CreateThread();
		cout << "Created Thread (ID): " << tid[i] << endl;
        	}
	cout << "Created " << numthreads << " Threads...." << endl;
	for (int i=0; i<numthreads; i++)
       		{
        	JoinThread(tid[i]);
        	}
       	cout << "--" << endl;
	cout << "Done." << endl;
	}

pthread_t CreateThread()
{
        void *arg;
        pthread_t thread_temp;
        pthread_attr_t attr;
        pthread_attr_init(&attr);
	pthread_attr_setscope(&attr, PTHREAD_SCOPE_SYSTEM);
        pthread_create(&thread_temp, &attr, robsort, &arg);
        return thread_temp;
}

void JoinThread(pthread_t tid)
{
        pthread_join(tid, NULL);
        return;
}


void * robsort(void *)
	{	
	const int maxArraySize = 100;
	int randpos, asize, bsize;
	int a[maxArraySize];
	int b[maxArraySize];
	int backup[maxArraySize];
	int sortcounter = 0;
	ifstream fin("sortdata.txt");
	if (!fin) 
		{
        	cerr << "ERROR:  Failed to open file 'Data'." << endl;
        	cerr << "Aborting..." << endl;
        	exit(1);
		}
    	int size = 0;
    	int value;
	while ((size < maxArraySize) && (fin >> value))
		{	
		a[size++] = value;
		}
        cout << "Sorting (thread): ";
	for (int i = 0; i < size; i++)
		{
        	cout << a[i] << ' ';
		}
	cout << endl;
	asize = size;
	bsize = size;
	int sorted=0;
	for (int b1=0; b1 < size;b1++)
		{
		backup[b1] = a[b1];
		}

	srand(time(NULL));

	time_t timeon, timeoff;
	double duration;

	time (&timeon);

	do 
		{

		asize = size;
		for (int j=0; j < bsize; j++)
			{
			randpos = rand()%asize;
			b[j] = a[randpos];
			int temp[asize];
			int tempcounter=0;

			for (int k=0; k < asize; k++)
				{
				if (k != randpos)
					{
					temp[tempcounter] = a[k];
					a[k]=0;
					tempcounter++;
					}
				else
					{
					a[k]=0;
					}
				}

			for (int l=0; l < asize;l++)
				{
				a[l] = temp[l];
				}
			asize--;
			}

		/* Uncomment this if you want to see a lot of numbers

       		cout << "Sorting: ";
	
		for (int i=0; i < size; i++)
			{
        		cout << b[i] << ' ';
			}

		cout << endl;

		*/
		
		for (int c=0; c < size;)
			{
			int firstval=b[c];
			int secondval=b[c+1];
			if (firstval <= secondval)
				{
				if (c+1==size-1)
					{
					sorted=1;
					}
				c++;
				}
			else
				{
				c=size;
				}			
			}	
		for (int b2=0; b2 < size;b2++)
			{
			a[b2] = backup[b2];
			}	

		sortcounter++;
		} while (sorted==0);
       	cout << "--" << endl;
       	cout << "Sorted!: ";
	for (int i=0; i < size; i++)
		{
        	cout << b[i] << ' ';
		}
	cout << endl;
	cout << "Randomly arranged " << sortcounter << " times." << endl;

	time (&timeoff);
	duration = difftime (timeoff, timeon);

	double seconds = duration;
	double minutes = seconds / 60;
	double hours = minutes / 60;
	double days = minutes / 1440;
	
	cout << "Duration: " << seconds << " seconds; ";
	cout << minutes << " minutes; ";
	cout << hours << " hours; ";
	cout << days << " days " << endl;
	return(NULL);
	}



